VERSION 5.00
Begin VB.Form key 
   Caption         =   "Amzaing Text Editor"
   ClientHeight    =   3495
   ClientLeft      =   3000
   ClientTop       =   2880
   ClientWidth     =   6570
   LinkTopic       =   "Form1"
   ScaleHeight     =   3495
   ScaleWidth      =   6570
   Begin VB.TextBox txtMain 
      Height          =   1575
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu itmNew 
         Caption         =   "&New"
      End
      Begin VB.Menu itmOpen 
         Caption         =   "&Open..."
      End
      Begin VB.Menu itmSave 
         Caption         =   "&Save..."
         Shortcut        =   ^S
      End
      Begin VB.Menu sepOne 
         Caption         =   "-"
      End
      Begin VB.Menu itmSettings 
         Caption         =   "Se&ttings"
         Begin VB.Menu itmBlackOnWhite 
            Caption         =   "Black on White"
            Checked         =   -1  'True
         End
         Begin VB.Menu itmWhiteOnBlack 
            Caption         =   "White on Black"
         End
      End
      Begin VB.Menu itmAbout 
         Caption         =   "&About..."
      End
      Begin VB.Menu sepTwo 
         Caption         =   "-"
      End
      Begin VB.Menu itmExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu itmUndo 
         Caption         =   "&Undo"
         Shortcut        =   ^Z
      End
      Begin VB.Menu sepThree 
         Caption         =   "-"
      End
      Begin VB.Menu itmCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu itmCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu itmPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu sepFour 
         Caption         =   "-"
      End
      Begin VB.Menu itmSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "key"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public strGFUndoBuffer  As String   'Global variable to hold undo string
Public intGFCursorPos As Integer    'Current position of cusor in string

Private Sub Form_Resize()
    txtMain.Top = 0
    txtMain.Left = 0
    txtMain.Width = ScaleWidth
    txtMain.Height = ScaleHeight
End Sub

Private Sub itmAbout_Click()
    Dim strMsg As String
       
    strMsg = " Amazing Text Editor" & vbCrLf
    strMsg = strMsg & "By Bob Reselman" & vbCrLf
    strMsg = strMsg & Chr$(169) & " Macmillan Publishers 1998"

    MsgBox strMsg, vbOKOnly, "About"
End Sub

Private Sub itmBlackOnWhite_Click()
    'Set the color scheme for Black on White
    txtMain.BackColor = vbWhite
    txtMain.ForeColor = vbBlack
    
    'Set the menu checks accordingly
    itmBlackOnWhite.Checked = True
    itmWhiteOnBlack.Checked = False
End Sub

Private Sub itmCut_Click()
    Dim strLeft As String   'Variable to hold text from left of cursor
    Dim strRight As String  'Variable to hold text from right of cusort
    Dim strFull As String   'Full text
    
    'Get the position of the cursor within the
    'text box
    intGFCursorPos = txtMain.SelStart
    'Get all the text within the text box
    strFull = txtMain.Text
    
    'Determine the text on the left side fo the cursor
    strLeft = Left(strFull, intGFCursorPos)
    
    'Determine the text on the right side of the cursor excluding
    'the selected text.
    strRight = Right(strFull, Len(strFull) - (intGFCursorPos + txtMain.SelLength))
    
    'Send the selected text to the clipboard
    Clipboard.SetText (txtMain.SelText)
    
    'Send the existing text to an Undo buffer
    strGFUndoBuffer = txtMain.Text
    
    '"Cut" the selected text out of the text in the text box.
    'The construct a new string with the remaining text.
    txtMain.Text = strLeft & strRight
    
    'Set the curor to the cut point
    txtMain.SelStart = intGFCursorPos
End Sub

Private Sub itmExit_Click()
    Dim strMsg As String
        
    strMsg = "Are you sure you want to quit?"
    
    If MsgBox(strMsg, vbYesNo + vbQuestion, _
            "Exiting Text Editor") = vbYes Then
        End
    End If
End Sub

Private Sub itmNew_Click()
    Call NoImplement
End Sub

Public Sub NoImplement()
    '****************************************
    'Sub/Function: NoImplement
    '
    'Variables: None
    '
    'Return: None
    '
    'Remarks:   This sub shows a message box informing the
    '           user that an intended feature is not implemented
    '
    'Programmer: Bob Reselman
    '   updated: Richard Peasley 6/98
    '
    'Copyright 1998, Macmillan Publishers
    '****************************************
    MsgBox "Not Implemented", vbInformation
End Sub

Private Sub itmOpen_Click()
     Call NoImplement
End Sub

Private Sub itmPaste_Click()
    Dim strTemp As String   'Text from clipboard
    Dim strLeft As String   'Variable to hold text from left of cursor
    Dim strRight As String  'Variable to hold text from right of cusort
    Dim strFull As String   'Full text
    
    'Get the text from the clipboard
    strTemp = Clipboard.GetText(vbCFText)
    'Get the position of the cursor within the
    'text box
    intGFCursorPos = txtMain.SelStart
    'Get all the text within the text box
    strFull = txtMain.Text
    
    'Determine the text on the left side fo the cursor
    strLeft = Left(strFull, intGFCursorPos)
    
    'Determine the text on the right side of the cursor excluding
    'the selected text.
    strRight = Right(strFull, Len(strFull) - (intGFCursorPos + txtMain.SelLength))
    
    'Send the existing text to an Undo buffer
    strGFUndoBuffer = txtMain.Text
    
    '"Paste" the selected text into the text in the text box.
    txtMain.Text = strLeft & strTemp & strRight
    
    'Set the curor to the paste point
    intGFCursorPos = Len(strLeft & strTemp)
    
    txtMain.SelStart = intGFCursorPos
End Sub

Private Sub itmSave_Click()
    Call NoImplement
End Sub
Private Sub itmSelectAll_Click()
    txtMain.SelStart = 0
    txtMain.SelLength = Len(txtMain.Text)
End Sub

Private Sub itmUndo_Click()
    txtMain.Text = strGFUndoBuffer
    
    'Set the curor to the cut point
    txtMain.SelStart = intGFCursorPos
End Sub

Private Sub itmWhiteOnBlack_Click()
    txtMain.BackColor = vbBlack
    txtMain.ForeColor = vbWhite
    itmBlackOnWhite.Checked = False
    itmWhiteOnBlack.Checked = True
End Sub

Private Sub itmCopy_Click()
    Clipboard.SetText txtMain.SelText
End Sub
