VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DBTransporter"
   ClientHeight    =   4275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4650
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4275
   ScaleWidth      =   4650
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdQuit 
      Caption         =   "&Quit"
      Height          =   495
      Left            =   3240
      TabIndex        =   6
      Top             =   3600
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "4. Transport to Excel"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   3600
      Width           =   2655
   End
   Begin VB.CommandButton cmdOpenDB 
      Caption         =   "1. Select an Access Database..."
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   2655
   End
   Begin VB.ListBox lstFields 
      Height          =   1815
      Left            =   240
      MultiSelect     =   2  'Extended
      TabIndex        =   1
      Top             =   1680
      Width           =   2415
   End
   Begin VB.ComboBox cboTables 
      Height          =   315
      Left            =   240
      TabIndex        =   0
      Top             =   960
      Width           =   2415
   End
   Begin MSComDlg.CommonDialog cdlgMain 
      Left            =   2760
      Top             =   3360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.Label Label2 
      BackStyle       =   0  'Transparent
      Caption         =   "3. Select one or more fields"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1440
      Width           =   2055
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "2. Select a table"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Const ACCESS_SYSTEM_PREFIX = "MSYS"
Private Const MAXIMUM_RECS = 20
Private Const TRANS_MSG = "DBTransporter is transporting..."
Private Const DEFAULT_XLS_FILENAME = "DBTrans"

Public gf_strDbPath As String   'Access Database Filename
                                'and FilePath
                                
                                


Private Sub cboTables_Click()
    Dim ws As Workspace     'Workspace object variable
    Dim db As Database      'Database object variablw
    Dim tdef As TableDef    'Table object variable
    Dim i%                  'Counter variable
    Dim strFieldName As String  'String to hold field names
    '******************************************
    'Programmer: Bob Reselman
    '
    '
    'Description: When the user clicks the tables ComboBox
    'this procedure:
    '-- Clears out the fields ListBox
    '-- Opens a DB and assigns it to an object var
    '-- Gets all the fields in the selected table
    '-- Adds them to the fields ListBox
    '-- Closes the database
    '
    '
    'History: Opened 3/15/98
    '******************************************
    
    'Clear out the fields List of any previous entries
    lstFields.Clear
    
    'Open a workspace and database
    Set ws = DBEngine.Workspaces(0)
    Set db = ws.OpenDatabase(gf_strDbPath)
    'Cycle through all the fields that are in the selected
    'table
    Set tdef = db.TableDefs(cboTables.List(cboTables.ListIndex))
    'and add the field names to the list box
    For i% = 0 To tdef.Fields.Count - 1
        lstFields.AddItem tdef.Fields(i%).Name
    Next i%
    'Close up shop
    db.Close
    ws.Close
End Sub

Private Sub cmdOpenDB_Click()
    Dim ws As Workspace     'Workspace object variable
    Dim db As Database      'Database object variable
    Dim strTblName As String 'String to hold table name
    Dim strFilter As String 'String to hold field name
    Dim strMsg As String    'String to hold MsgBox messages
    Dim iReturn As Integer  'MsgBox return variable
    Dim i%                  'Counter variable
    
    '******************************************
    'Programmer: Bob Reselman
    '
    '
    'Description: When the user clicks the CommandButton
    'this procedure:
    '-- Sets the CommonDialog filter to allow for MDB files
    '-- Opens a CommonDialog
    '-- Get all the tables of the selected DB
    '-- Adds them to the tables ComboBox
    '-- Closes the database
    '
    '
    'History: Opened 3/15/98
    '******************************************
    
    'Find a database string to open
    'Set the CommonDialog file filter
    strFilter = "Access DB (*.mdb)|*.mdb"
    cdlgMain.Filter = strFilter
    'Open the CommonDialog
    cdlgMain.ShowOpen
    'In case the user does not select a file, keep prompting
    'until they "Just Say No".
    'Go into a the While loop if the user has not picked
    'a file
    While gf_strDbPath = ""
        'Get the filename from the CommonDialog
        gf_strDbPath = cdlgMain.filename
        'Null string means that they have not selected a
        'DB file
        If gf_strDbPath = "" Then
            strMsg = "You have not selected a file."
            strMsg = strMsg & vbCrLf & vbCrLf
            strMsg = strMsg & "Do you want to select one now?"
            'Ask the user if they want to try again to
            'a file
            iReturn = MsgBox(strMsg, vbCritical + vbYesNo, "Selection Error")
            If iReturn = vbNo Then
                'If the user does not want to go on, then
                'exit this sub
                Exit Sub
            Else
                'Show 'em the CommonDialog again
                cdlgMain.ShowOpen
            End If
        End If
    Wend
    'Open a workspace and database
    Set ws = DBEngine.Workspaces(0)
    Set db = ws.OpenDatabase(gf_strDbPath)
    
    'Clear out the Tables ComboBox of any previous entries
    cboTables.Clear
        
    'Find the Tables in the DB then
    'cycle through the tables and put the
    'table names in the Table ComboBox
    For i% = 0 To db.TableDefs.Count - 1
        'Get the table name
        strTblName = db.TableDefs(i%).Name
        'Make sure the table names are not the Access
        'system tables. (These tables begin with, MSys )
        If Left(UCase(strTblName), 4) <> _
            ACCESS_SYSTEM_PREFIX Then
            cboTables.AddItem strTblName
        End If
    Next i%
    
    'OK, you've got all the tables in the DB so
    'close up shop
    db.Close
    ws.Close
End Sub

Private Sub cmdQuit_Click()
    End
End Sub

Private Sub cmdSave_Click()
    Dim xla As New Excel.Application    'Excel object var
    Dim xlb As New Excel.Workbook       'Workbook object var
    Dim xls As New Excel.Worksheet      'Worksheet object var
    Dim xlr As Excel.Range              'Range object var
    Dim ws As Workspace                 'Workspace var for DB
    Dim db As Database                  'Database variable
    Dim rs As Recordset                 'Recordset variable
    Dim strSQL As String                'String to hold SQL
                                        'statements
    Dim i%, j%, k% 'Counter variables
    Dim rc%         'RecordCount variable
    Dim r%, c%      'Excel row and column variables
    
    Dim strFields() As String   'An array of strings that
                                'hold the selected field names
                                'of a table
    
    Dim strTable As String      'String to hold table name
    Dim strMsg As String        'MsgBox message string
    Dim strBuffer As String     'String Buffer
    Dim strFilter As String     'CommonDialog filter string
     
    '******************************************
    'Programmer: Bob Reselman
    '
    '
    'Description: When the user clicks the CommandButton
    'this procedure:
    '-- Assigns all the fields selected in the fields
    '   ListBox to a string array
    '-- Opens a DB
    '-- Instantiates an Excel session and spreadsheet
    '-- Cycles through the string array, retrieving all the
    '   records of each field individually
    '-- As each set of records for each field is retrieved,
    '   the field name is assigned to top row of the Excel
    '   spreadsheet. Then, each record is added to that
    '   column, down a cell at a time, until the recordset
    '   is exhausted.
    '-- Once the recordset for that field is exhausted, the
    '   Excel cursor is moved right, to the top of the next
    '   column and the same process of column header and
    '   then record-to-cell is repeated until all fields
    '   have been accommodated.
    '-- The user is then asked it they want to save the
    '   Excel spreadsheet to a file. If not, the Excel
    '   session is closed.
    '
    'History: Opened 3/15/98
    '******************************************d
    
    'Get a count of all the selected fields in the fields
    'ComboBox
    For i% = 0 To lstFields.ListCount - 1
        If lstFields.Selected(i%) = True Then
            j% = j% + 1
        End If
    Next i%
    
    'Make sure at least one field was selected
    If j% - 1 = -1 Then
        strMsg = "You must select at least one field."
        strMsg = strMsg & vbCrLf & vbCrLf
        strMsg = strMsg & "Please select a field in the Field Listbox"
        MsgBox strMsg, vbCritical, "Field Selection Error"
        lstFields.SetFocus
        'Leave town
        Exit Sub
    End If
    
    'Now redimemsion the strFields array to hold the names
    'of the selected fields
    ReDim strFields(j% - 1)
    
    'Disable the controls so that the user cannot drive the
    'program nuts.
    cmdQuit.Enabled = False
    cmdSave.Enabled = False
    cmdOpenDB.Enabled = False
    cboTables.Enabled = False
    lstFields.Enabled = False
    
    'Set the Mousepointer to an hourglass
    frmMain.MousePointer = 11
    
    'Put the current Form caption in the string buffer
    strBuffer = frmMain.Caption
    
    'Notify the user that the program is doing its thing
    frmMain.Caption = TRANS_MSG
    
    'Clear out j%, you'll need it later
    j% = 0
    
    'Cycle through the Fields Listbox again and add the selected
    'fields to the fields string array
    For i% = 0 To lstFields.ListCount - 1
        If lstFields.Selected(i%) = True Then
            strFields(j%) = lstFields.List(i%)
            j% = j% + 1
        End If
    Next i%
    
    'Determine the table name for later use
    strTable = cboTables.Text
    
    'Open a workspace and database
    Set ws = DBEngine.Workspaces(0)
    Set db = ws.OpenDatabase(gf_strDbPath)
    
    'Open an Excel Workbook and WorkSheet
    Set xlb = xla.Workbooks.Add
    Set xls = xlb.Worksheets.Add
    
    'Make the new sheet active
    xls.Activate
    'Cycle through all the fields, retrieving the the data
    'for each field. Do this by making an SQL statement for
    'each field and passing it to the DB as request for a
    'recordset.
    For i% = 0 To UBound(strFields)
        strSQL = "SELECT " & strTable & ".[" & strFields(i%) & "]"
        strSQL = strSQL & " FROM " & strTable
        Set rs = db.OpenRecordset(strSQL)
        
        'Move through the recordset to get a recordcount
        rs.MoveLast
        rs.MoveFirst
        
        'Set the Excel column the field counter variable
        c% = i% + 1
        'Set the number of rows to the number of records returned
        'by the query
        j% = 0
        
        'Put the title of the field in the first row
        xls.Cells(1, c%) = strFields(i%)
        'make the font style bold for the column header
        Set xlr = xls.Cells(1, c%)
        xlr.Select
        xlr.Font.Bold = True
        

        '=============================================
        '             Caution
        '=============================================
        'For purposes of demonstration we'll limit the
        'Recordcount to MAXIMUM_RECS records. If you want
        'to be able to use this code with out this prevention
        'adjust the following If...Then...Else statement. Be
        'advised that this could take some time!!!!
        
        If rs.RecordCount > MAXIMUM_RECS Then
            rc% = MAXIMUM_RECS
        Else
            rc% = rs.RecordCount
        End If
        'Go through each record in the recordset and
        'assign it to rows in sequence. Remeber that
        'you need to start in Excel sheet row 2 because
        'the first row is used to title the column
        For r% = 2 To rc% + 1
            xls.Cells(r%, c%) = rs(strFields(i%))
            rs.MoveNext
        Next r%
    Next i%
        
    
    'Set the Mousepointer to default
    frmMain.MousePointer = 0
    
    'Reset the Form's caption
    frmMain.Caption = strBuffer
    
    'Let the user know that the operation is succesful
    strMsg = "Access file: " & vbCrLf & vbCrLf
    strMsg = strMsg & gf_strDbPath & vbCrLf & vbCrLf
    strMsg = strMsg & "has been successfully transported."
    
    MsgBox strMsg, vbExclamation, "Transport successful"
    
    'Enable the controls
    cmdQuit.Enabled = True
    cmdSave.Enabled = True
    cmdOpenDB.Enabled = True
    cboTables.Enabled = True
    lstFields.Enabled = True

    'Ask the user if s/he wants to save the spreadsheet
    strMsg = "DBTransporter has transported the Access data "
    strMsg = strMsg & "to an Excel spreadsheet."
    strMsg = strMsg & vbCrLf & vbCrLf
    strMsg = strMsg & "Do you want to save the Excel spreadsheet?"

    If MsgBox(strMsg, vbQuestion & vbYesNo) = vbYes Then
        'Open the CommonDialog in save as mode
        'with an Excel spreadsheet filter
        strFilter = "Excel Spreadsheet (*.xls)|*.xls"
        cdlgMain.Filter = strFilter
        'Show the default filename
        cdlgMain.filename = DEFAULT_XLS_FILENAME
        cdlgMain.ShowSave


        If cdlgMain.filename <> "" Then
            'Save the ExcelSpread sheet
            xls.SaveAs (cdlgMain.filename)
            'Let the user know the location of the file
            strMsg = "Access data has been saved to file:"
            strMsg = strMsg & vbCrLf & vbCrLf
            strMsg = strMsg & cdlgMain.filename
            MsgBox strMsg, vbExclamation, "Spreadsheet saved"
        End If
    End If
    'Mark the Excel workbook saved so that the user will
    'not be prompted to save the work book.
    xlb.Saved = True
    
    'Quit the Excel Appliation.
    xla.Quit
End Sub

